; Set up environment.
#NoEnv
#SingleInstance, Off
SetBatchLines, -1
SetControlDelay, -1
DetectHiddenWindows, On
SetWorkingDir, %A_ScriptDir%

Gui, 1: Margin, 3, 5
Gui, 1: +Resize
Gui, 1: Add, Text     , xm ym     w150 h20  0x200                      , Paste email addresses here:
Gui, 1: Add, Edit     , xm ym+20  w200 h300       vList_edt            , 
Gui, 1: Add, Button   , xm ym+325 w200 h20        vCreate_btn gGenerate, Create CTT file
Gui, 1: Add, StatusBar,

Gui, 1: Show, AutoSize Center, CTT Generator

Return ; End of auto-execute section.


; ------------------------------------------------------------------------
; Subroutines ------------------------------------------------------------
; ------------------------------------------------------------------------

Generate:
{
    Full_Block    := ""
    Contact_Block := ""
     
    Gui, 1: Submit, NoHide ;  Initialise GUI variables.
    
    ; Replace tabs with linefeeds in case we're pasting in from a spreadsheet.
    StringReplace, List_edt, List_edt, %A_Tab%, `n
    
    ; Build out the email address block.
    Loop, Parse, List_edt, `n
    {
        If ( A_LoopField != "" ) ; Skips the trailing `n at the end of the dataset.
        {
            Contact_Block .= "      <contact>" . A_LoopField . "</contact>`n"
        }
    }
    StringTrimRight, Contact_Block, Contact_Block, 1 ; Trim the trailing `n.

    ; Build out the full file.
    Full_Block =
    ( LTrim
        <?xml version="1.0"?>
        <messenger>
        %A_Space%%A_Space%<service name=".NET Messenger Service">
        %A_Space%%A_Space%%A_Space%%A_Space%<contactlist>
        %Contact_Block%
        %A_Space%%A_Space%%A_Space%%A_Space%</contactlist>
        %A_Space%%A_Space%</service>
        </messenger>
    )

    ; Save the file.
    Gui, +OwnDialogs
    FileSelectFile, Dest_Filename, S16, %A_ScriptDir%, Save CTT file, *.ctt ; Trailing backslash needed.
    ; ----------
    If ( Dest_Filename != "" ) ; User did not click cancel.
    {
        IfExist, %Dest_Filename%
        {
            FileDelete, %Dest_Filename%
        }
        If ( ERRORLEVEL != 0 )
        {
            MsgBox, 48, Error, Error saving file.  The file may already be open by another application.
        }
        Else
        {
            SplitPath, Dest_Filename, , , OutExtension
            If ( OutExtension = "" )
            {
                Dest_Filename := Dest_Filename . ".ctt"
            }
            FileAppend, % Full_Block, % Dest_Filename
        }
    }
}
Return


GuiEscape:
GuiClose:
{
    ExitApp
}
Return


GuiSize:
{
    Anchor( "List_edt"  , "wh", 0 )
    Anchor( "Create_btn", "yw", 0 )
}
Return


; ------------------------------------------------------------------------
; Third party functions --------------------------------------------------
; ------------------------------------------------------------------------

; http://www.autohotkey.com/forum/topic4348.html
Anchor(c, a = "", r = false) { ; v3.6 - Titan
    ;OutputDebug, c: %c%
    static d
    GuiControlGet, p, Pos, %c%
    If ex := ErrorLevel {
        Gui, %A_Gui%:+LastFound
        ControlGetPos, px, py, pw, ph, %c%
    }
    If !(A_Gui or px) and a
        Return
    i = x.w.y.h./.7.%A_GuiWidth%.%A_GuiHeight%.`n%A_Gui%:%c%=
    StringSplit, i, i, .
    d := a ? d . ((n := !InStr(d, i9)) ? i9 : "")
        : RegExReplace(d, "\n\d+:" . c . "=[\-\.\d\/]+")
    Loop, 4
        x := A_Index, j := i%x%, i6 += x = 3
        , k := !RegExMatch(a, j . "([\d.]+)", v) + (v1 ? v1 : 0)
        , e := p%j% - i%i6% * k, d .= n ? e . i5 : ""
        , RegExMatch(d, "\Q" . i9 . "\E(?:([\d.\-]+)/){" . x . "}", v)
        , l .= p%j% := InStr(a, j) ? (ex ? "" : j) . v1 + i%i6% * k : ""
    If r
        rx = Draw
    If ex
        ControlMove, %c%, px, py, pw, ph
    Else GuiControl, Move%rx%, %c%, %l%
}
